Metadata-Version: 2.4
Name: apimatic-mx-apis-sdk
Version: 0.0.1
Summary: This is a test SDK
Author-email: developer sdksio <developer+sdksio@apimatic.io>
Project-URL: Documentation, https://apimatic.io
Keywords: APIMatic,sdksio
Requires-Python: >=3.7
Description-Content-Type: text/markdown
License-File: LICENSE
Requires-Dist: apimatic-core>=0.2.24,~=0.2.0
Requires-Dist: apimatic-core-interfaces>=0.1.8,~=0.1.0
Requires-Dist: apimatic-requests-client-adapter>=0.1.10,~=0.1.0
Requires-Dist: python-dotenv<2.0,>=0.21
Requires-Dist: deprecation~=2.1
Provides-Extra: testutils
Requires-Dist: pytest>=7.2.2; extra == "testutils"
Dynamic: license-file


# Getting Started with MX Platform API

## Introduction

The MX Platform API is a powerful, fully-featured API designed to make aggregating and enhancing financial data easy and reliable. It can seamlessly connect your app or website to tens of thousands of financial institutions.

### What's Changed?

Several endpoints, headers, and fields changed in `v20250224`. For more on breaking changes, refer to our [versioning](/api-reference/platform-api/overview/versioning#v20250224) and [migration](/api-reference/platform-api/overview/migration) guides.

### Version Header

Versions are set in the `Accept-Version` header of API requests. Version numbers correspond with the date associated with that version.  The example below uses the version `v20250224`.

```
-H 'Accept: application/json'
-H 'Accept-Version: v20250224'
```

---


## Install the Package

The package is compatible with Python versions `3.7+`.
Install the package from PyPi using the following pip command:

```bash
pip install apimatic-mx-apis-sdk==0.0.1
```

You can also view the package at:
https://pypi.python.org/pypi/apimatic-mx-apis-sdk/0.0.1

## Initialize the API Client

**_Note:_** Documentation for the client can be found [here.](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/client.md)

The following parameters are configurable for the API Client:

| Parameter | Type | Description |
|  --- | --- | --- |
| environment | [`Environment`](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/README.md#environments) | The API environment. 
 **Default: `Environment.PRODUCTION`** |
| http_client_instance | `Union[Session, HttpClientProvider]` | The Http Client passed from the sdk user for making requests |
| override_http_client_configuration | `bool` | The value which determines to override properties of the passed Http Client from the sdk user |
| http_call_back | `HttpCallBack` | The callback value that is invoked before and after an HTTP call is made to an endpoint |
| timeout | `float` | The value to use for connection timeout. 
 **Default: 30** |
| max_retries | `int` | The number of times to retry an endpoint call if it fails. 
 **Default: 0** |
| backoff_factor | `float` | A backoff factor to apply between attempts after the second try. 
 **Default: 2** |
| retry_statuses | `Array of int` | The http statuses on which retry is to be done. 
 **Default: [408, 413, 429, 500, 502, 503, 504, 521, 522, 524]** |
| retry_methods | `Array of string` | The http methods on which retry is to be done. 
 **Default: ["GET", "PUT"]** |
| proxy_settings | [`ProxySettings`](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/proxy-settings.md) | Optional proxy configuration to route HTTP requests through a proxy server. |
| logging_configuration | [`LoggingConfiguration`](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/logging-configuration.md) | The SDK logging configuration for API calls |
| basic_auth_credentials | [`BasicAuthCredentials`](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/auth/basic-authentication.md) | The credential object for Basic Authentication |
| bearer_auth_credentials | [`BearerAuthCredentials`](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/auth/oauth-2-bearer-token.md) | The credential object for OAuth 2 Bearer token |

The API client can be initialized as follows:

### Code-Based Client Initialization

```python
import logging

from mxplatformapi.configuration import Environment
from mxplatformapi.http.auth.basic_auth import BasicAuthCredentials
from mxplatformapi.http.auth.bearer_auth import BearerAuthCredentials
from mxplatformapi.logging.configuration.api_logging_configuration import LoggingConfiguration
from mxplatformapi.logging.configuration.api_logging_configuration import RequestLoggingConfiguration
from mxplatformapi.logging.configuration.api_logging_configuration import ResponseLoggingConfiguration
from mxplatformapi.mxplatformapi_client import MxplatformapiClient

client = MxplatformapiClient(
    basic_auth_credentials=BasicAuthCredentials(
        username='Username',
        password='Password'
    ),
    bearer_auth_credentials=BearerAuthCredentials(
        access_token='AccessToken'
    ),
    environment=Environment.PRODUCTION,
    logging_configuration=LoggingConfiguration(
        log_level=logging.INFO,
        request_logging_config=RequestLoggingConfiguration(
            log_body=True
        ),
        response_logging_config=ResponseLoggingConfiguration(
            log_headers=True
        )
    )
)
```

### Environment-Based Client Initialization

```python
from mxplatformapi.mxplatformapi_client import MxplatformapiClient

# Specify the path to your .env file if it’s located outside the project’s root directory.
client = MxplatformapiClient.from_environment(dotenv_path='/path/to/.env')
```

See the [Environment-Based Client Initialization](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/environment-based-client-initialization.md) section for details.

## Environments

The SDK can be configured to use a different environment for making API calls. Available environments are:

### Fields

| Name | Description |
|  --- | --- |
| PRODUCTION | **Default** |
| ENVIRONMENT2 | - |

## Authorization

This API uses the following authentication schemes.

* [`basicAuth (Basic Authentication)`](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/auth/basic-authentication.md)
* [`bearerAuth (OAuth 2 Bearer token)`](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/auth/oauth-2-bearer-token.md)

## List of APIs

* [Achreturn](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/achreturn.md)
* [Investmentholdings](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/investmentholdings.md)
* [Monthlycashflowprofile](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/monthlycashflowprofile.md)
* [Processortoken](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/processortoken.md)
* [Spendingplan](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/spendingplan.md)
* [Transactionrules](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/transactionrules.md)
* [Verifiablecredentials](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/verifiablecredentials.md)
* [Manageddata Deprecated](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/manageddata-deprecated.md)
* [Accounts](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/accounts.md)
* [Budgets](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/budgets.md)
* [Categories](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/categories.md)
* [Goals](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/goals.md)
* [Insights](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/insights.md)
* [Institutions](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/institutions.md)
* [Members](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/members.md)
* [Merchants](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/merchants.md)
* [Microdeposits](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/microdeposits.md)
* [Notifications](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/notifications.md)
* [Rewards](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/rewards.md)
* [Statements](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/statements.md)
* [Taggings](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/taggings.md)
* [Tags](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/tags.md)
* [Transactions](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/transactions.md)
* [Users](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/users.md)
* [Widgets](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/widgets.md)
* [Jobs](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/controllers/jobs.md)

## SDK Infrastructure

### Configuration

* [ProxySettings](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/proxy-settings.md)
* [Environment-Based Client Initialization](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/environment-based-client-initialization.md)
* [AbstractLogger](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/abstract-logger.md)
* [LoggingConfiguration](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/logging-configuration.md)
* [RequestLoggingConfiguration](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/request-logging-configuration.md)
* [ResponseLoggingConfiguration](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/response-logging-configuration.md)

### HTTP

* [HttpResponse](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/http-response.md)
* [HttpRequest](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/http-request.md)

### Utilities

* [ApiResponse](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/api-response.md)
* [ApiHelper](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/api-helper.md)
* [HttpDateTime](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/http-date-time.md)
* [RFC3339DateTime](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/rfc3339-date-time.md)
* [UnixDateTime](https://www.github.com/sdks-io/apimatic-mx-apis-python-sdk/tree/0.0.1/doc/unix-date-time.md)

